@echo off
REM Written by senshu (2008/11/04)
pushd ..

echo ======= Build hidmon.exe =======
cd src
make clean
make
make install
make clean
cd ..

echo ======= Build DLL =======
cd dll
make clean
make
make install
make clean
cd ..

echo ======= Build firmware =======

del bin\firmware\main*.hex
cd firmware

REM make HIDaspx (MONITOR only)
make MAIN=main-small F_CPU=12800000 clean
make MAIN=main-small F_CPU=12800000 
make MAIN=main-small F_CPU=12800000  install

REM make for libusb
make -f Makefile.unix clean
make -f Makefile.unix
make -f Makefile.unix install

REM make default (HIDaspx)
make clean
make
make install

REM cleanup
make clean
make MAIN=main-small clean
make -f Makefile.unix clean
cd ..
echo ======= Build DLL TEST program =======
cd test
copy ..\bin\*.dll
cd ..
echo ======= All update. =======
popd
pause
