/*********************************************************************
 *	USBoR̃^[Qbg[ANZX
 *********************************************************************
 *API:
int		UsbInit(char *string);									// .
int		UsbExit(void);											// I.
int 	UsbPoke(int adr,int arena,int data,int mask);			// 
int 	UsbPeek(int adr,int arena);								// 1oCgǂݏo
int		PortAddress(char *string);

 *
void UsbBench(int cnt,int psize);								//	x`}[N
int  UsbRead(int adr,int arena,uchar *buf,int size);			// Aǂݏo
void UsbDump(int adr,int arena,int size);						// [_v

 *֐:
static void	dump_mem(int adr,int cnt);
static void	poke_mem(int adr,int data0,int data1);
static void	memdump_print(void *ptr,int len,int off);

 * 2009N17
 USBɐڑĂ|[g̑ɂ́A\ȒӂKvłB
 ATtiny2313ATmega88/168ł́AAhXƃrbg̊ĂقȂ̂ŁA
 ^[Qbg𔻒ɂꂼ̏sĂ܂B

 */

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <time.h>
#include <math.h>

#include "hidasp.h"
#include "monit.h"
#include "util.h"
#include "hidcmd.h"

#include "portlist.h"

extern PortList portList[];

// ^[QbgID: HIDaspxł́A0x55  0x5a eB
// bootmonł́A0x8x ԂƂzB
extern int dev_id;
int hidmon_mode = 1;

#define	VERBOSE	0

#define	if_V	if(VERBOSE)

//static    char verbose_mode = 0;
static int HidLength1 = 7;
static int HidLength = 31;

// ReportID:4  POLLING PORTςł.
static int pollcmd_implemented;

//  ی|[g
#define	PROTECTED_PORT_MAX	3
static int protected_ports[PROTECTED_PORT_MAX] = { -1, -1, -1 };

#define	PROTECTED_PORT_MASK_2313	0x38	// 0011_1000
#define	PROTECTED_PORT_MASK_88		0x0C	// 0000_1100


#define	ID4		4
#define	LENGTH4	5


DLL_int PortAddress(const char *string)
{
	int adr = portAddress(string);
	if (adr == 0)
		adr = -1;
	return adr;
}


/****************************************************************************
 *	[e_v.
 ****************************************************************************
 *	void *ptr : _vf[^.
 *	int   len : _voCg.
 *	int   off : ^[Qbg̔Ԓn\.
 */
static void memdump_print(void *ptr, int len, int off)
{
	unsigned char *p = (unsigned char *) ptr;
	int i, j, c;

	for (i = 0; i < len; i++) {
		if ((i & 15) == 0) {
			printf("%06x", (int) p - (int) ptr + off);
		}
		printf(" %02x", *p);
		p++;
		if ((i & 15) == 15) {
#if	1							// ASCII DUMP
			printf("  ");
			for (j = 0; j < 16; j++) {
				c = p[j - 16];
				if (c < ' ')
					c = '.';
				if (c >= 0x7f)
					c = '.';
				printf("%c", c);
			}
#endif
			printf("\n");
		}
	}
	printf("\n");
}



/*********************************************************************
 *	AVRfoCXɏR}h𑗂āAKvȂ猋ʂ󂯎.
 *********************************************************************
 *	cmdBuf   *cmd : R}h
 *	uchar    *buf : ʂ󂯎̈.
 *  int reply_len : ʂ̕KvTCY. (0̏ꍇ͌ʂ󂯎Ȃ)
 *߂l
 *		-1	 : Ms
 *		0	 : Ms
 *	̐ : iHidD_GetFeature̖߂l)
 */
int QueryAVR(cmdBuf * cmd, uchar * buf, int reply_len)
{
	int rc = 0;
	int report_id = cmd->report_id;
	int size = cmd->size;
	char *s;

	rc = hidWriteBuffer((char *) cmd, HidLength1);
	if (rc == 0) {
#if VERBOSE
		printf("hidWrite error\n");
#endif
		return -1;
	}
	if (reply_len) {
		rc = hidReadBuffer((char *) cmd, reply_len);
		if (rc == 0) {
			if (report_id != 4) {
#if VERBOSE
				printf("hidRead error %d\n", report_id);
#endif
				return 0;
			}
		}
		s = (char *) cmd;
		memcpy(buf, s + 1, size);
	}
	return rc;
}

/*********************************************************************
 *	^[Qbg̃[e擾
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           size :ǂݎTCY.
 *	unsigned char *buf :󂯎obt@.
 *	: HID Report Length - 1 蒷TCY͗vĂ͂ȂȂ.
 */
static int dump_mem(int adr, int arena, int size, unsigned char *buf)
{
	cmdBuf cmd;

	memset(&cmd, 0, sizeof(cmdBuf));
	cmd.cmd = CMD_PEEK;			//| arena;
	cmd.size = size;
	cmd.adr[0] = adr;
	cmd.adr[1] = adr >> 8;

	if (QueryAVR(&cmd, buf, 1 + size) < 0)
		return -1;				//s.
	return size;
}

/*********************************************************************
 *	^[Qbg̃[e(1oCg).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int          data0 :݃f[^.      (OR)
 *	int          data1 :݃rbg}XN.(AND)
 *:
 *	t@[̏݃ASY͈ȉ̂悤ɂȂĂ̂Œ.

	if(data1) {	//}XNt̏.
		*adr = (*adr & data1) | data0;
	}else{			//ׂ.
		*adr = data0;
	}

 */

static int poke_mem(int adr, int arena, int data0, int data1)
{
	cmdBuf cmd;
	char buf[16];				// dummy

	memset(&cmd, 0, sizeof(cmdBuf));
	cmd.cmd = CMD_POKE;			//| arena;
	cmd.size = 1;
	cmd.adr[0] = adr;
	cmd.adr[1] = adr >> 8;
	cmd.data[0] = data0;
	cmd.data[1] = data1;
	return QueryAVR(&cmd, buf, 0);
}

/*********************************************************************
 *	^[QbgƂ̐ڑ`FbN(x`}[N˂)
 *********************************************************************
 *	int i : 0`255 ̐l.
 *߂l
 *		GR[obNꂽ i ̒l.
 */
static int hid_ping(int i)
{
	cmdBuf cmd;
	char buf[128];				// dummy
	int rc;

	memset(&cmd, i, sizeof(cmdBuf));
	cmd.cmd = CMD_PING;
	QueryAVR(&cmd, buf, 0);

	rc = hidReadBuffer(buf, HidLength);
	if (rc == 0) {
#if VERBOSE
		printf("hidRead error\n");
#endif
		return -1;
	}
	return buf[2] & 0xff;
}

/*********************************************************************
 *	]xx`}[N
 *********************************************************************
 *	int cnt  : PINGł.
 *	int psize: PINGpPbg̑傫(݂̓T|[gȂ)
 */
void UsbBench(int cnt, int psize)
{
	int i, n, rc;
	int time1, rate;
	int total = 0;
	int nBytes = HidLength1 + HidLength;	//݌Œ.
	// 1Ping 7byteQuery31oCg̃^[.

	printf("hid write start\n");
	int time0 = clock();

	for (i = 0; i < cnt; i++) {
		n = i & 0xff;
		rc = hid_ping(n);
		if (rc != n) {
			printf("hid ping mismatch error (%x != %x)\n", rc, n);
			return;
		}
		total += nBytes;
	}

	time1 = clock() - time0;
	if (time1 == 0) {
		time1 = 2;
	}
	rate = total * 1000 / time1;

	printf("hid write end, %d bytes/%d ms,  %d bytes/s\n", total, time1,  rate);
}

/*********************************************************************
 *	^[Qbg[_v.
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int            cnt :ǂݎTCY.
 */
void UsbDump(int adr, int arena, int cnt)
{
	unsigned char buf[16];
	int size;
	int rc;
	while (cnt) {
		size = cnt;
		if (size >= 8)
			size = 8;
		rc = dump_mem(adr, arena, size, buf);	//[e̓ǂݏo.

		if (rc != size)
			return;
		memdump_print(buf, size, adr);	//ʈ.
		adr += size;
		cnt -= size;
	}
}

/*********************************************************************
 *	^[Qbg[Aǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	uchar         *buf :ǂݎobt@.
 *	int           size :ǂݎTCY.
 *߂l
 *	-1    : s
 *	̒l: .
 */
int UsbRead(int adr, int arena, uchar * buf, int size)
{
	int rc = size;
	int len;
	while (size) {
		len = size;
		if (len >= 8)
			len = 8;
		rc = dump_mem(adr, arena, len, buf);
		if (rc != len) {
			return -1;
		}
		adr += len;				// ^[QbgAhXi߂.
		buf += len;				// ǂݍݐobt@i߂.
		size -= len;			// cTCY炷.
	}
	return rc;
}

/*********************************************************************
 *	^[Qbg[1oCgǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 *	ǂݏoɎsꍇ (-1)Ԃ.
 */
DLL_int UsbPeek(int adr, int arena)
{
	unsigned char buf[16];
	int size = 1;
	int rc = UsbRead(adr, arena, buf, size);
	if (rc != size) {
		return -1;
	}
	return buf[0];
}

static int poll_port = 0;

/*********************************************************************
 *	^[Qbg[1oCgAǂݏõZbgAbv
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbSetPoll_slow(int adr, int arena)
{
	poll_port = adr;
	return 1;
}

/*********************************************************************
 *	^[Qbg[1oCgAǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
int UsbPoll_slow()
{
	return UsbPeek(poll_port, 0);
}

/*********************************************************************
 *	^[Qbg[1oCgAǂݏõZbgAbv
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
DLL_int UsbSetPoll(int adr, int arena)
{
	char buf[128];
	char rd_buf[128];

	if (pollcmd_implemented == 0) {
		return UsbSetPoll_slow(adr, arena);
	}

	memset(buf, 0, sizeof(buf));

	buf[0] = ID4;
	buf[1] = CMD_SETPAGE;
	buf[2] = 0;					// page_mode
	buf[3] = adr;				// page_addr
	buf[4] = adr >> 8;			// page_addr_h

	if (QueryAVR((cmdBuf *) buf, rd_buf, 0) == 0)
		return 0;				//s.
	return 1;
}

/*********************************************************************
 *	^[Qbg[1oCgAǂݏo
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *߂l
 *	[e̒l.
 */
DLL_int UsbPoll(void)
{
	char buf[128];				// dummy
	int rc;

	if (pollcmd_implemented == 0) {
		return UsbPoll_slow();
	}

	rc = hidReadPoll(buf, LENGTH4, ID4);
	if (rc == 0) {
#if	0
		printf("hidRead error\n");
		exit(1);
#else
		return -1;
#endif
	}
	return buf[1] & 0xff;
}


/*********************************************************************
 *	^[QbgɃAiOrR}h𔭍sA^C}[v.
 *********************************************************************
 *	int           mode : 0xa0 = ďv
 *	                   : 0xa1 = AIN0    ďv
 *	                   : 0xa2 = d푪Rő|Čv
 *	unsigned char *abuf: vʂԋp̈(Œ5byteAŜ128bytep)
 *߂l
 *		0	 : Ms
 *	̐ : iHidD_GetFeature̖߂l)
 */
DLL_int UsbAnalogPoll(int mode,unsigned char *abuf)
{
	hidCommand(HIDASP_SET_PAGE,mode,0,0);	// Set Page mode
	if(mode == 0xa2) {
		Sleep(3);
	}
	int rc = hidReadPoll(abuf , LENGTH4 ,ID4);
//	Sleep(100);
	return rc;
}


enum {
	AIN_MODE_NONE = 0,			// A/Dϊ~.
	AIN_MODE_VREF = 0xa0,		//dv.
	AIN_MODE_AIN0 = 0xa1,		//AIN0    dv.
	AIN_MODE_REGISTANCE = 0xa2,	//AIN0-PD6Ԃ̒Rv.
};


double volt_vcc			=5.00;
double volt_ref			=1.10;
double reference_k_ohm	=2.200;

#define	VOLT_VCC		volt_vcc
#define	VOLT_REF		volt_ref
#define	REFERENCE_K_OHM	reference_k_ohm

#define	VAL_10_MEGOHM	10000.0


/*********************************************************************
 *	AiOp[^ݒ肷.
 *********************************************************************
double volt_vcc			=5.00;
double volt_ref			=1.10;
double reference_k_ohm	=2.200;

   {Ăяoȗꍇ́AL̒lgp܂B
   ꕔ̃p[^̃ZbgAbvȗꍇ́Al -1 ɂ
   .
 */
DLL_int UsbAnalogSetup(double Vcc,double Vref,double Ref_k_Ohm)
{
	if(Vcc  > 0 )     { volt_vcc = Vcc; }
	if(Vref > 0 )     { volt_ref = Vref;}
	if(Ref_k_Ohm > 0) { reference_k_ohm = Ref_k_Ohm; }

	return 0;
}


/*********************************************************************
 *	d@
 *********************************************************************
Vref(1.23V)̂ƂTrefƁA
Vin(xxx V)̂ƂTin USBoRŎ擾āA
1.23V=5.0V * (1-exp(-Tref/RC)) ɂāARC̐ς̒l𓾂
Vin  =5.0V * (1-exp(-Tin/RC)) vZ΂njB  
5V̐xeĂƎvB

RC̋tZ exp(-Tref/RC))=1-(1.23/5.0)=0.754
RC = Tref/0.28236
 *********************************************************************
 */

double AnalogCalcVoltage(int Tref,int Tin)
{
	double Vin,RC;
	if((Tref == 0xffff)) {
		return 0.0;			//QƑ̌ʂȂ̂Ōvo.
	}
	if((Tin == 0xffff)) {
		return VOLT_VCC;	//TIMER1ߊlo. VCC킸ɒĂ\.
	}
	RC  = (double) Tref / log( 1.0 - (VOLT_REF/VOLT_VCC) ) * -1.0;
	Vin = VOLT_VCC * (1.0 - exp( -1.0 * ((double) Tin / RC )));

#if	ANALOG_CALC_DEBUG
	{	double R,C,RC1;
		RC1 = RC / 12000000.0;	// NbN.
		R = 2.2 * 1000.0;	// R=2.2kƂ.
		C = RC1 / R;
		printf("\n   RC=%12g , C=%12g uF\n",RC1,C * 1000000.0);
	}
#endif

	return Vin;
}

double AnalogCalcRegistance(int Tref,int Tin)
{
	double regval=-1.0;
	if( (Tref == 0xffff) ) {
		//R vZoȂ.
		return -1.0;
	}
	if( (Tin == 0xffff) ) {
		regval = VAL_10_MEGOHM;	//vł.
	}else{
		regval = (double) REFERENCE_K_OHM * Tin / Tref;
	}
	return regval;
}

/*********************************************************************
 *	AiO
 *********************************************************************
 *	int        inpmode : 0 = d
 *	                   : 1 = R
 *߂l
 *	double       -1     : vɎs.
 *			     0.0 ` 5.0   : dl.
 *				 0.0 ` 999.0 : Rl(Pʂ͂)
 *				 10000.0      : RliꉞPOlj
 */
DLL_double UsbAnalogInput(int inpmode)
{
	int mode,Tref,Tin;
	unsigned char abuf[256];
	double volt,regist;

	if( inpmode==0) {
		//d.
		mode = AIN_MODE_VREF ; 
		UsbAnalogPoll(mode,abuf);
		if( abuf[1] != mode ) {return -1.0;}
		Tref = abuf[2] + (abuf[3]<<8);

		mode = AIN_MODE_AIN0 ; 
		UsbAnalogPoll(mode,abuf);
		if( abuf[1] != mode ) {return -1.0;}
		Tin  = abuf[2] + (abuf[3]<<8);

		volt = AnalogCalcVoltage(Tref,Tin);
		return volt;
	}else{
		//R.
		mode = AIN_MODE_VREF ; 
		UsbAnalogPoll(mode,abuf);
		if( abuf[1] != mode ) {return -1.0;}
		Tref = abuf[2] + (abuf[3]<<8);

		mode = AIN_MODE_REGISTANCE ; 
		UsbAnalogPoll(mode,abuf);
		if( abuf[1] != mode ) {return -1.0;}
		Tin = abuf[2] + (abuf[3]<<8);

		regist = AnalogCalcRegistance(Tref,Tin);
		return regist;
	}
}



/*********************************************************************
 *	^[Qbg̃[e(1oCg).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           data :݃f[^.
 *	int           mask :ݗLrbg}XN.
 *
 *  mask  = 0 ̏ꍇ͑SrbgL ()
 *	mask != 0 ̏ꍇ́Amaskrbg1ɑΉdatâݍXVA͕ύXȂ.
 */
static int usb_poke(int adr, int arena, int data, int mask)
{
	int data0, data1;
	if (mask == 0) {
		// }XNsv̒.
		data0 = data;
		data1 = 0;
	} else {
		// }XN܂ޏ.
		// ݃f[^̗L mask ̃rbg 1 ɂȂĂ镔̂.
		// mask ̃rbg 0 ł镔́Ȁێ.

		data0 = data & mask;	// OR.
		data1 = 0xff & (~mask);	// AND.

		// }XÑ݂WbN͈ȉ.
		// *mem = (*mem & data1) | data0;
	}

	return poke_mem(adr, arena, data0, data1);
}

/*********************************************************************
 *	^[Qbg̃[e(1oCg).
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int           data :݃f[^.
 *	int           mask :ݗLrbg}XN.
 *
 *  mask  = 0 ̏ꍇ͑SrbgL ()
 *	mask != 0 ̏ꍇ́Amaskrbg1ɑΉdatâݍXVA͕ύXȂ.
 */
DLL_int UsbPoke(int adr, int arena, int data, int mask)
{
	int i;
	int f = 0;
	for (i = 0; i < PROTECTED_PORT_MAX; i++) {
		if (adr == protected_ports[i])
			f = 1;
	}

	if (f == 0)
		return usb_poke(adr, arena, data, mask);

	if (mask == 0)
		mask = 0xff;
	if ((dev_id & 0xf0) == 0x50) {
		mask &= ~PROTECTED_PORT_MASK_2313;	// USB D+,D-,PULLUP rbg̏}XN.
		data &= ~PROTECTED_PORT_MASK_2313;
	} else {
		mask &= ~PROTECTED_PORT_MASK_88;	// USB D+,D- rbg̏}XN.
		data &= ~PROTECTED_PORT_MASK_88;
	}

	if (adr == protected_ports[0]) {
		mask = 0;
	}							// pind mask writeĂ͂Ȃ.

	return usb_poke(adr, arena, data, mask);
}

/*********************************************************************
 *	1rbg̏
 *********************************************************************
 *	int            adr :^[Qbg̃[AhX
 *	int          arena :^[Qbg̃[(ݖgp)
 *	int            bit :݃f[^(1bit) 0  1
 *	int           mask :ݗLrbg}XN.
 */
void UsbPoke_b(int adr, int arena, int bit, int mask)
{
	int data = 0;
	if (mask == 0) {
		//1oCg̏.
		UsbPoke(adr, arena, bit, 0);
	} else {
		//1rbg̏.
		if (bit)
			data = 0xff;
		UsbPoke(adr, arena, data, mask);
	}
}

/*********************************************************************
 *
 *********************************************************************
 */
static void local_init(void)
{
	if ((dev_id & 0xf0) == 0x50) {
		protected_ports[0] = portAddress("pind");
		protected_ports[1] = portAddress("portd");
		protected_ports[2] = portAddress("ddrd");
	} else {	/* for ATmega88/168 */
		protected_ports[0] = 0x29;	/* PIND */
		protected_ports[1] = 0x2b;	/* PORTD */
		protected_ports[2] = 0x2a;	/* DDRD */
	}
}

/*********************************************************************
 *
 *********************************************************************
 */
static void UsbCheckPollCmd(void)
{
	pollcmd_implemented = 1;	// Ƃ肠ĂƉ.
	{
		int gtccr = portAddress("gtccr");	// LSB̂10̃|[g.
		int data;
		int rc = UsbSetPoll(gtccr, 0);

		if (rc == 0) {			// s.
			pollcmd_implemented = 0;	// ĂȂƔ.
			return;
		}

		data = UsbPoll();
		if ((data == (-1)) || (data & 0xfe)) {
			pollcmd_implemented = 0;	// ĂȂƔ.
		}
	}
}

/*********************************************************************
 *	
 *********************************************************************
 */
DLL_int UsbInit(const char *string)
{
	int rc;
//  verbose_mode = verbose;
	if (*string == '*') {
		string = "0000";
	}
	rc = hidasp_init(string);
	if (rc == HIDASP_MODE_ERROR) {
#if VERBOSE
		printf("error: device[%s] not found!\n", string);
#endif
		return -1;
	}
	local_init();
	UsbCheckPollCmd();
	return dev_id;					// OK.
}

/*********************************************************************
 *	I
 *********************************************************************
 */
DLL_int UsbExit(void)
{
	hidasp_close();
	return 0;					// OK.
}

/*********************************************************************
 *
 *********************************************************************
 */

/*
 * DLLGg|Cg֐̌^ƓT^IȃXPgR[h
 */
BOOL APIENTRY					/* int __stdcall */
DllMain(HINSTANCE hInstance, DWORD ul_reason_for_call, LPVOID pParam)
{
	switch (ul_reason_for_call) {
	case DLL_PROCESS_ATTACH:
		/* ɃO[oϐ̏R[h */
		/* loaddll DLL[h͂s */
		break;

	case DLL_PROCESS_DETACH:
		/* ɃO[oϐ̌nR[h */
		/* freedll DLLA[h͂s */
		break;

	case DLL_THREAD_ATTACH:
		/* ɃXbhɕKvȕϐ̏R[h */
		break;

	case DLL_THREAD_DETACH:
		/* ɃXbhɕKvȕϐ̌nR[h */
		break;
	}
	return TRUE;
}
