/**********************************************************************
 *	AiOr LpV^[dԌvɂ A/D ϊ̎.
 **********************************************************************
 *	ϊHɂ

(alt.Vref)                          v[u͂Q.
AIN0>----------===>-  Rmeter Vmeter <-+-- <--+-
                                     Rin     |
PD6>----R1K--*-===>-  Rmeter        <-+-     Vin
             |                               |
AIN1>--------*       +===>-  Vmeter       <--+-
             |       |
    0.047uF ===      |
             |       |
            GND     GND

 *	  AIN1 ɃLpV^ƃvAbvRqő|܂B
 *	  ϊ AIN1  L ɂ LpV^d܂B
 *	  AiOd  AIN0 ɐڑĂB
 *
 *	A/D ϊɂ
 *  page_mode == 0xa0 ̂Ƃ.
 *    AIN0  d(1.23V)ɐݒ肵̂AAIN1AiO͂ɂ܂B
 *    ɁATIMER1X^[g܂B
 *
 *  PollR}hɑ΂鉞
 *    TIMER1ߊlJE^(ߊlFAIN1 > AIN0)̒lԂ܂B
 *	  ߊlĂȂꍇ 0xffff Ԃ܂B
 *
 *  page_mode == 0xa1 ̂Ƃ.
 *    AIN0  r͂ɐݒ肵̂AAIN1AiO͂ɂ܂B
 *    ɁATIMER1X^[g܂B
 *
 *  PollR}hɑ΂鉞 page_mode == 0xa0̂ƂƓłB
 *
 *	R蓮ɂ
 *	  AIN0 o̓|[gƂĎgA푪RPULLUPđ|܂B
 *	  PD6  ͎QƒR(1K)łB
 *  page_mode == 0xa2 ̂Ƃ.
 *    AIN0  d(1.23V)ɐݒ肵̂AAIN1AiO͂ɂ܂B
 *    ɁATIMER1X^[g܂B
 *    PD6̓I[vɂāAAIN0Hixɂ܂B
 *  R̎Qƌv page_mode == 0xa0 ƓłB
 *
 *  PollR}h̖߂pPbg\.
 *  i 5 bytes j
 *  [Report ID] [ page_mode ] [ Timer1_L ] [ Timer1_H ] [ reserved ]
 *
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#ifndef uchar
#define uchar   unsigned char
#endif

#include "hidconfig.h"
#include "timer.h"
#include "adc.h"

/**********************************************************************
 *	vAbvQƒR(1k)gpď[d.
 **********************************************************************
 */
static	inline void PD6_Hi()
{
	PORTD |=  (1<<6);	// Hi
	DDRD  |=  (1<<6);	// PD6: Out
}
/**********************************************************************
 *	vAbvQƒR(1k)gpȂ. PD6Hi-Zɂ.
 **********************************************************************
 */
static	inline void PD6_Open()
{
	PORTD &= ~(1<<6);	// Lo
	DDRD  &= ~(1<<6);	// PD6: Hi-Z
}

/**********************************************************************
 *	PB1:charge			:: AIN1 AiO͂ɂ.
 **********************************************************************
 */
static inline void AIN0_Hi()
{
	PORTB |=  (1<<0);		//      Hi
	DDRB  |=  (1<<0);		// PB0: H
}
/**********************************************************************
 *	vAbvQƒR(1k)gpȂ. PD6Hi-Zɂ.
 **********************************************************************
 */
static	inline void AIN0_Open()
{
	PORTB &= ~(1<<0);	//      Lo
	DDRB  &= ~(1<<0);	// PB0: Hi-Z
}

/**********************************************************************
 *	PB1:charge			:: AIN1 AiO͂ɂ.
 **********************************************************************
 */
static inline void charge_start()
{
	PORTB &= ~(1<<1);	//      Lo
	DDRB  &= ~(1<<1);	// PB1: Hi-Z
}
/**********************************************************************
 *	PB1:discharge :: AIN1 fW^k xo͂ɂăLpV^d.
 **********************************************************************
 */
static void inline discharge_start()
{
	//AIN1ɑ΂fW^͋.
	DIDR   = 0b00000000;

	PORTB &= ~(1<<1);		//      Lo
	DDRB  |=  (1<<1);		// PB1: Lo
}
/**********************************************************************
 *	`/c ϊn|[g̏.
 **********************************************************************
 */
void  adc_init(void)
{
	//A/DϊpWX^ݒ.
//	ADCSRA = 0b10000000;
	//AiOr평.
//	ADCSRB = 0b00000000;

	//d1.1VƔr / Timer1ߊlOn. / GbWł̊荞.
	ACSR   = 0b01000110;
	//AIN1ɑ΂fW^͋֎~.
//	DIDR   = 0b00000010;
}
/**********************************************************************
 *	
 **********************************************************************
 *	mode
 *		0xa0 : kick Vref mode (Voltage and Registance)
 *		0xa1 : kick AIN0 mode (Voltage)
 *		0xa2 : kick AIN0 mode (for measuring Registance)
 */
void  adc_start(uchar mode)
{
	if(mode == 0) {		// `/cϊ̒~.
		// ACSR.
		ACSR   = 0b00000000;
		//AIN1ɑ΂fW^͋.
		DIDR   = 0b00000000;
		// PD6J.
		PD6_Open();
		AIN0_Open();
		
		return;
	}

	// ==== AiOr̓͐؂ւ.
	if(	mode == 0xa1 ) {	// AIN0 d.
		//AIN0 Ɣr        / Timer1ߊlOn. / GbWł̊荞.
		ACSR   = 0b00000110;
	}else{					// d . ͒R.
		//d1.1VƔr / Timer1ߊlOn. / GbWł̊荞.
		ACSR   = 0b01000110;
	}
	
	
	// ==== vAbvĨRg[.
	if(	mode == 0xa2 ) {
		PD6_Open();		// R胂[hŔ푪RI.
		AIN0_Hi();		// ɔ푪Rgpď[d.
	}else{
		PD6_Hi();		// vAbvQƒR(1k)gpď[d.
		AIN0_Open();
	}

	ICR1H=0xff;			// TIMER1 ߊlJE^.
	ICR1L=0xff;			// TIMER1 ߊlJE^.

	//AIN1ɑ΂fW^͋֎~.
//	DIDR   = 0b00000010;
	
	cli();
	// ==== AIN1 [dJn.
	charge_start();
	
	//16bit counter: ǂނƂL,H,ƂH,L.
	TCNT1H=0;
	TCNT1L=0;
	sei();
}
/**********************************************************************
 *	
 **********************************************************************
 */
void adc_report(uchar *buf)
{
	uchar l,h;
	//ǂނƂL,H.
	l=ICR1L;		// TIMER1 ߊlJE^.
	h=ICR1H;		// TIMER1 ߊlJE^.
	
#if	1
	if( (l & h)== 0xff ) {	// hl ==0xffff
		// ߊlĂȂꍇ.
		if((ACSR & (1<<5))==0) {	// bit5=ACO analog_comp(AIN0-AIN1)
			// [{gߕ?  AIN0(Vin) < AIN1(|) 
			l=h=0;
		}
	}
#endif
	buf[1]=l;
	buf[2]=h;

	// PD6J.
	PD6_Open();
	AIN0_Open();
	// ==== AIN1 dJn.
	discharge_start();
}


/**********************************************************************
 *	timer : 荞݃nh[.
 **********************************************************************
 */
#if	0
ISR(TIMER1_OVF_vect)
{
}
#endif
/**********************************************************************
 *	
 **********************************************************************
 */
