/**********************************************************************
 *	16bit TIMER1 gp荞݃nh[.
 **********************************************************************
 *	timer_init()
 *	timer_wait()
 */
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

#ifndef uchar
#define uchar   unsigned char
#endif

#include "hidconfig.h"
//#include "task.h"
#include "timer.h"


volatile int   timer_count;			//NĂ̎.(tick)
volatile int   timer_count_high;	//NĂ̎.(tick/65536)

volatile uchar timer_tick;			//^C}[荞ݔtO.

#define	TIMER_DA_OUT			0	//^C}[荞݂̃^C~OD/Ao͂L.
#define	USE_TIMER1_INTERRUPT	0	//^C}[荞݂gp.


#if		TIMER_DA_OUT				//^C}[荞݂̃^C~OD/Ao͂L.
static	 uchar timer_daout;			//^C}[荞݂̃^C~OD/Ao.
#endif


void kbd_int_handler(void);

/**********************************************************************
 *	.
 **********************************************************************
 */
void timer_init(int cnt)
{
	timer_count = 0;

	TCCR1A = 0b00000011;	// Porto͂off
	TCCR1B = 0b00011001;	// WGM=1111 (PWM) CS1=001 (CLK/1)

	OCR1AH = (cnt >> 8);
	OCR1AL =  cnt;

#if	USE_TIMER1_INTERRUPT
#ifdef	__AVR_ATtiny2313__
	TIMSK = 0b10000000;		// ATtiny2313 : TOIE1=1 (Overflow Interrupt)
#else
	TIMSK1 = 0b00000001;	// ATmega88   : TOIE1=1 (Overflow Interrupt)
#endif
#endif
}

#if	USE_TIMER1_INTERRUPT

/**********************************************************************
 *	Ɋ荞ނ܂ő҂.
 **********************************************************************
 */
uchar timer_wait(void)
{
	while(timer_tick == 0) { /* nothing */ };
	timer_tick --;
	return timer_tick;
}
/**********************************************************************
 *	
 **********************************************************************
 */
uchar timer_gettick(void)
{
	return timer_tick;
}
/**********************************************************************
 *
 **********************************************************************
 */
int timer_gettime(void)
{
	return timer_count;
}
/**********************************************************************
 *	timer : 荞݃nh[.
 **********************************************************************
 */
ISR(TIMER1_OVF_vect)
{
#if		TIMER_DA_OUT				//^C}[荞݂̃^C~OD/Ao͂L.
	OCR0A = timer_daout;
#endif
	timer_count ++;
	if(	timer_count==0) {
		timer_count_high++;
	}
	timer_tick ++;
}
#endif
/**********************************************************************
 *	
 **********************************************************************
 */
